<?php

declare(strict_types=1);

namespace Pinpoint\TaxSwitch\Plugin\Magento\Tax\Helper;

use Magento\Tax\Helper\Data;
use Pinpoint\TaxSwitch\Api\ConfigHelperInterface;

/**
 * This class is responsible for intercepting methods in \Magento\Tax\Helper\Data
 */
class DataPlugin
{
    /**
     * @var \Pinpoint\TaxSwitch\Api\ConfigHelperInterface
     */
    private $configHelper;

    /**
     * @param \Pinpoint\TaxSwitch\Api\ConfigHelperInterface $configHelper
     */
    public function __construct(ConfigHelperInterface $configHelper)
    {
        $this->configHelper = $configHelper;
    }

    /**
     * @param Data                                       $subject
     * @param bool                                       $result
     * @param int|\Magento\Store\Model\Store|string|null $store
     *
     * @return bool
     */
    public function afterDisplayBothPrices(Data $subject, bool $result, $store = null): bool
    {
        if (!$result) {
            $result = $this->configHelper->isEnabled();
        }

        return $result;
    }
}
